Index: /trunk/base/Mk/macports.autoconf.mk.in
===================================================================
--- /trunk/base/Mk/macports.autoconf.mk.in	(revision 123001)
+++ /trunk/base/Mk/macports.autoconf.mk.in	(revision 123002)
@@ -71,3 +71,5 @@
 portsdir		= @PORTSDIR@
 
+MACPORTS_VERSION	= @MACPORTS_VERSION@
+
 SILENT			= @
Index: /trunk/base/configure.ac
===================================================================
--- /trunk/base/configure.ac	(revision 123001)
+++ /trunk/base/configure.ac	(revision 123002)
@@ -146,4 +146,5 @@
 AC_PATH_PROG(LZMA, [lzma], [])
 AC_PATH_PROG(MAKE, [make])
+AC_PATH_PROG(MAN, [man])
 AC_PATH_PROG(MDFIND, [mdfind], [])
 AC_PATH_PROG(MDLS, [mdls], [])
@@ -169,5 +170,4 @@
 
 AC_CHECK_PROG(HAVE_LAUNCHD, [launchd], [yes], [], [/sbin])
-
 
 if test "x$MTREE" = "x"; then
Index: /trunk/base/doc/TODO
===================================================================
--- /trunk/base/doc/TODO	(revision 123002)
+++ /trunk/base/doc/TODO	(revision 123002)
@@ -0,0 +1,8 @@
+TODO:
+
+    - [options="compact"] not supported by docbook for manpage output
+    - split global-options.txt into macro which allows display selection
+
+Missing new man pages:
+
+    - portarchives(7)
Index: /trunk/base/doc/asciidoc-deps.tcl
===================================================================
--- /trunk/base/doc/asciidoc-deps.tcl	(revision 123002)
+++ /trunk/base/doc/asciidoc-deps.tcl	(revision 123002)
@@ -0,0 +1,35 @@
+#!/usr/bin/env tclsh
+# -*- coding: utf-8; mode: tcl; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- vim:fenc=utf-8:filetype=tcl:et:sw=4:ts=4:sts=4
+
+if {[llength $::argv] == 0} {
+    puts "Usage: ${::argv0} <*.txt>"
+    exit 1
+}
+
+# Dependency storage
+array set deps {}
+
+# Gather includes
+foreach file $::argv {
+    if {![file exists $file]} {
+        continue
+    }
+    set fd [open "$file" r]
+    set cont [read $fd]
+    close $fd
+    set deplst [regexp -all -inline -- {include::([^\[]*)\[\]} $cont]
+    if {[llength $deplst] > 0} {
+        set deps($file) $deplst
+    }
+}
+
+# Output
+foreach {file deplst} [array get deps] {
+    puts -nonewline "[file rootname $file].xml [file rootname $file].html:"
+    foreach {match dep} $deplst {
+        puts -nonewline " $dep"
+    }
+    puts ""
+}
+
+exit 0
Index: /trunk/base/doc/asciidoc.conf
===================================================================
--- /trunk/base/doc/asciidoc.conf	(revision 123002)
+++ /trunk/base/doc/asciidoc.conf	(revision 123002)
@@ -0,0 +1,45 @@
+[attributes]
+mansource=MacPorts
+#manversion is in the Makefile
+manmanual=MacPorts Manual
+guideurl=http://guide.macports.org/
+wikiurl=https://trac.macports.org/wiki/
+
+## man: macro
+#
+# Usage: man:command[manpage-section]
+#
+# Note, {0} is the manpage section, while {target} is the command.
+#
+# Show link as: <command>(<section>); if section is defined, else just show
+# the command.
+
+[macros]
+(?su)[\\]?(?P<name>man):(?P<target>\S*?)\[(?P<attrlist>.*?)\]=
+(?su)[\\]?(?P<name>guide):(?P<target>\S*?)\[(?P<attrlist>.*?)\]=
+(?su)[\\]?(?P<name>wiki):(?P<target>\S*?)\[(?P<attrlist>.*?)\]=
+
+# man: and guide: for docbook
+ifdef::backend-docbook[]
+[man-inlinemacro]
+<citerefentry>
+    <refentrytitle>{target}</refentrytitle>{0?<manvolnum>{0}</manvolnum>}
+</citerefentry>
+[guide-inlinemacro]
+<ulink url="{guideurl}#{target}">{0={guideurl}{target}}</ulink>
+[wiki-inlinemacro]
+<ulink url="{wikiurl}{target}">{0={target}}</ulink>
+endif::backend-docbook[]
+
+# man: and guide: for xhtml11
+ifdef::backend-xhtml11[]
+[man-inlinemacro]
+<a href="{target}{0?.{0}}.html">{target}{0?({0})}</a>
+[guide-inlinemacro]
+<a href="{guideurl}#{target}">{0={guideurl}{target}}</a>
+[wiki-inlinemacro]
+<a href="{wikiurl}{target}">{0={target}}</a>
+endif::backend-xhtml11[]
+
+[paradef-default]
+cmdsynopsis-style=template="verseparagraph"
Index: /trunk/base/doc/manpage.xsl
===================================================================
--- /trunk/base/doc/manpage.xsl	(revision 123002)
+++ /trunk/base/doc/manpage.xsl	(revision 123002)
@@ -0,0 +1,18 @@
+<?xml version='1.0' ?>
+<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
+
+<xsl:import href="http://docbook.sourceforge.net/release/xsl/current/manpages/docbook.xsl"/>
+
+<xsl:param name="man.endnotes.list.heading">External References</xsl:param>
+<xsl:param name="man.authors.section.enabled">0</xsl:param>
+<xsl:param name="man.copyright.section.enabled">0</xsl:param>
+
+<!-- Do not write soelim files -->
+<xsl:template name="write.stubs">
+</xsl:template>
+
+<!-- Remove top comment with build date -->
+<xsl:template name="top.comment">
+</xsl:template>
+
+</xsl:stylesheet>
Index: /trunk/base/doc/port-build.1.soelim
===================================================================
--- /trunk/base/doc/port-build.1.soelim	(revision 123002)
+++ /trunk/base/doc/port-build.1.soelim	(revision 123002)
@@ -0,0 +1,1 @@
+.so man1/port-fetch.1
Index: /trunk/base/doc/port-checksum.1.soelim
===================================================================
--- /trunk/base/doc/port-checksum.1.soelim	(revision 123002)
+++ /trunk/base/doc/port-checksum.1.soelim	(revision 123002)
@@ -0,0 +1,1 @@
+.so man1/port-fetch.1
Index: /trunk/base/doc/port-configure.1.soelim
===================================================================
--- /trunk/base/doc/port-configure.1.soelim	(revision 123002)
+++ /trunk/base/doc/port-configure.1.soelim	(revision 123002)
@@ -0,0 +1,1 @@
+.so man1/port-fetch.1
Index: /trunk/base/doc/port-deactivate.1.soelim
===================================================================
--- /trunk/base/doc/port-deactivate.1.soelim	(revision 123002)
+++ /trunk/base/doc/port-deactivate.1.soelim	(revision 123002)
@@ -0,0 +1,1 @@
+.so man1/port-activate.1
Index: /trunk/base/doc/port-destroot.1.soelim
===================================================================
--- /trunk/base/doc/port-destroot.1.soelim	(revision 123002)
+++ /trunk/base/doc/port-destroot.1.soelim	(revision 123002)
@@ -0,0 +1,1 @@
+.so man1/port-fetch.1
Index: /trunk/base/doc/port-extract.1.soelim
===================================================================
--- /trunk/base/doc/port-extract.1.soelim	(revision 123002)
+++ /trunk/base/doc/port-extract.1.soelim	(revision 123002)
@@ -0,0 +1,1 @@
+.so man1/port-fetch.1
Index: /trunk/base/doc/port-patch.1.soelim
===================================================================
--- /trunk/base/doc/port-patch.1.soelim	(revision 123002)
+++ /trunk/base/doc/port-patch.1.soelim	(revision 123002)
@@ -0,0 +1,1 @@
+.so man1/port-fetch.1
Index: /trunk/base/src/macports1.0/macports_autoconf.tcl.in
===================================================================
--- /trunk/base/src/macports1.0/macports_autoconf.tcl.in	(revision 123001)
+++ /trunk/base/src/macports1.0/macports_autoconf.tcl.in	(revision 123002)
@@ -41,4 +41,5 @@
     variable macports_user_dir "~/.macports"
     variable macportsuser "@RUNUSR@"
+    variable man_path "@MAN@"
     variable mdfind_path "@MDFIND@"
     variable mdls_path "@MDLS@"
Index: /trunk/base/src/pextlib1.0/system.c
===================================================================
--- /trunk/base/src/pextlib1.0/system.c	(revision 123001)
+++ /trunk/base/src/pextlib1.0/system.c	(revision 123002)
@@ -108,5 +108,5 @@
 }
 
-/* usage: system ?-notty? ?-nice value? ?-W path? command */
+/* usage: system ?-notty? ?-nodup? ?-nice value? ?-W path? command */
 int SystemCmd(ClientData clientData UNUSED, Tcl_Interp *interp, int objc, Tcl_Obj *CONST objv[])
 {
@@ -123,4 +123,5 @@
     int fline, pos, ret;
     int osetsid = 0;
+    int odup = 1; /* redirect stdin/stdout/stderr by default */
     int oniceval = INT_MAX; /* magic value indicating no change */
     const char *path = NULL;
@@ -142,4 +143,6 @@
         if (strcmp(arg, "-notty") == 0) {
             osetsid = 1;
+        } else if (strcmp(arg, "-nodup") == 0) {
+            odup = 0;
         } else if (strcmp(arg, "-nice") == 0) {
             i++;
@@ -169,7 +172,9 @@
      * popen() itself is not used because stderr is also desired.
      */
-    if (pipe(fdset) != 0) {
-        Tcl_SetResult(interp, strerror(errno), TCL_STATIC);
-        return TCL_ERROR;
+    if (odup) {
+        if (pipe(fdset) != 0) {
+            Tcl_SetResult(interp, strerror(errno), TCL_STATIC);
+            return TCL_ERROR;
+        }
     }
 
@@ -181,11 +186,13 @@
         /*NOTREACHED*/
     case 0: /* child */
-        close(fdset[0]);
-
-        if ((nullfd = open(_PATH_DEVNULL, O_RDONLY)) == -1)
-            _exit(1);
-        dup2(nullfd, STDIN_FILENO);
-        dup2(fdset[1], STDOUT_FILENO);
-        dup2(fdset[1], STDERR_FILENO);
+        if (odup) {
+            close(fdset[0]);
+
+            if ((nullfd = open(_PATH_DEVNULL, O_RDONLY)) == -1)
+                _exit(1);
+            dup2(nullfd, STDIN_FILENO);
+            dup2(fdset[1], STDOUT_FILENO);
+            dup2(fdset[1], STDERR_FILENO);
+        }
         /* drop the controlling terminal if requested */
         if (osetsid) {
@@ -237,56 +244,58 @@
     }
 
-    close(fdset[1]);
-
-    /* read from simulated popen() pipe */
-    read_failed = 0;
-    pos = 0;
-    memset(circbuf, 0, sizeof(circbuf));
-    pdes = fdopen(fdset[0], "r");
-    if (pdes) {
-        while ((buf = fgetln(pdes, &linelen)) != NULL) {
-            char *sbuf;
-            size_t slen;
-    
-            /*
-             * Allocate enough space to insert a terminating
-             * '\0' if the line is not terminated with a '\n'
-             */
-            if (buf[linelen - 1] == '\n')
-                slen = linelen;
-            else
-                slen = linelen + 1;
-    
-            if (circbuf[pos].len == 0)
-                sbuf = malloc(slen);
-            else {
-                sbuf = realloc(circbuf[pos].line, slen);
-            }
-    
-            if (sbuf == NULL) {
-                read_failed = 1;
-                break;
-            }
-    
-            memcpy(sbuf, buf, linelen);
-            /* terminate line with '\0',replacing '\n' if it exists */
-            sbuf[slen - 1] = '\0';
-    
-            circbuf[pos].line = sbuf;
-            circbuf[pos].len = slen;
-    
-            if (pos++ == CBUFSIZ - 1) {
-                pos = 0;
-            }
-    
-            if (ui_info(interp, sbuf) != TCL_OK) {
-                read_failed = 1;
-                break;
-            }
-        }
-        fclose(pdes);
-    } else {
-        read_failed = 1;
-        Tcl_SetResult(interp, strerror(errno), TCL_STATIC);
+    if (odup) {
+        close(fdset[1]);
+
+        /* read from simulated popen() pipe */
+        read_failed = 0;
+        pos = 0;
+        memset(circbuf, 0, sizeof(circbuf));
+        pdes = fdopen(fdset[0], "r");
+        if (pdes) {
+            while ((buf = fgetln(pdes, &linelen)) != NULL) {
+                char *sbuf;
+                size_t slen;
+
+                /*
+                * Allocate enough space to insert a terminating
+                * '\0' if the line is not terminated with a '\n'
+                */
+                if (buf[linelen - 1] == '\n')
+                    slen = linelen;
+                else
+                    slen = linelen + 1;
+
+                if (circbuf[pos].len == 0)
+                    sbuf = malloc(slen);
+                else {
+                    sbuf = realloc(circbuf[pos].line, slen);
+                }
+
+                if (sbuf == NULL) {
+                    read_failed = 1;
+                    break;
+                }
+
+                memcpy(sbuf, buf, linelen);
+                /* terminate line with '\0',replacing '\n' if it exists */
+                sbuf[slen - 1] = '\0';
+
+                circbuf[pos].line = sbuf;
+                circbuf[pos].len = slen;
+
+                if (pos++ == CBUFSIZ - 1) {
+                    pos = 0;
+                }
+
+                if (ui_info(interp, sbuf) != TCL_OK) {
+                    read_failed = 1;
+                    break;
+                }
+            }
+            fclose(pdes);
+        } else {
+            read_failed = 1;
+            Tcl_SetResult(interp, strerror(errno), TCL_STATIC);
+        }
     }
 
@@ -325,9 +334,11 @@
     }
 
-    /* Cleanup. */
-    close(fdset[0]);
-    for (fline = 0; fline < CBUFSIZ; fline++) {
-        if (circbuf[fline].len != 0) {
-            free(circbuf[fline].line);
+    if (odup) {
+        /* Cleanup. */
+        close(fdset[0]);
+        for (fline = 0; fline < CBUFSIZ; fline++) {
+            if (circbuf[fline].len != 0) {
+                free(circbuf[fline].line);
+            }
         }
     }
Index: /trunk/base/src/port/port.tcl
===================================================================
--- /trunk/base/src/port/port.tcl	(revision 123001)
+++ /trunk/base/src/port/port.tcl	(revision 123002)
@@ -1821,36 +1821,59 @@
 
 proc action_help { action portlist opts } {
-    set helpfile "$macports::prefix/var/macports/port-help.tcl"
-
+    set manext ".gz"
     if {[llength $portlist] == 0} {
-        print_help
-        return 0
-    }
-
-    if {[file exists $helpfile]} {
-        if {[catch {source $helpfile} err]} {
-            puts stderr "Error reading helpfile $helpfile: $err"
+        set page "man1/port.1$manext"
+    } else {
+        set topic [lindex $portlist 0]
+
+        # Look for an action with the requested argument
+        set actions [find_action $topic]
+        if {[llength $actions] == 1} {
+            set page "man1/port-[lindex $actions 0].1$manext"
+        } else {
+            if {[llength $actions] > 1} {
+                ui_error "\"port help ${action}\" is ambiguous: \n  port help [join $actions "\n  port help "]"
+                return 1
+            }
+
+            # No valid command specified
+            set page ""
+        }
+    }
+
+    set pagepath ${macports::prefix}/share/man/$page
+    if {$page == "" || ![file exists $pagepath]} {
+        set page "man7/portundocumented.7$manext"
+        set pagepath ${macports::prefix}/share/man/$page
+    }
+
+    if {$pagepath != ""} {
+        ui_debug "Opening man page '$pagepath'"
+
+        # Restore our entire environment from start time.
+        # man might want to evaluate TERM
+        global env boot_env
+        array unset env_save; array set env_save [array get env]
+        array unset env *
+        if {${macports::macosx_version} == "10.5"} {
+            unsetenv *
+        }
+        array set env [array get boot_env]
+
+        if [catch {system -nodup "${macports::autoconf::man_path} $pagepath"} result] {
+            ui_debug "$::errorInfo"
+            ui_error "Unable to show man page using ${macports::autoconf::man_path}: $result"
             return 1
         }
+
+        # Restore internal MacPorts environment
+        array unset env *
+        if {${macports::macosx_version} == "10.5"} {
+            unsetenv *
+        }
+        array set env [array get env_save]
     } else {
-        puts stderr "Unable to open help file $helpfile"
+        ui_error "Sorry, no help for this topic is available."
         return 1
-    }
-
-    foreach topic $portlist {
-        if {![info exists porthelp($topic)]} {
-            puts stderr "No help for topic $topic"
-            return 1
-        }
-
-        set usage [action_get_usage $topic]
-        if {$usage != -1} {
-           puts -nonewline stderr $usage
-        } else {
-            ui_error "No usage for topic $topic"
-            return 1
-        }
-
-        puts stderr $porthelp($topic)
     }
 
